package ru.dbotthepony.mc.otm.menu;

import net.minecraft.world.Container;
import net.minecraft.world.SimpleContainer;
import net.minecraft.world.entity.player.Inventory;
import ru.dbotthepony.mc.otm.Registry;
import ru.dbotthepony.mc.otm.block.entity.BlockEntityMatterCapacitorBank;
import ru.dbotthepony.mc.otm.capability.IMatterHandler;
import ru.dbotthepony.mc.otm.menu.slot.MatterContainerInputSlot;
import ru.dbotthepony.mc.otm.menu.widget.MatterLevelWidget;

public class MatterCapacitorBankMenu extends MatteryMenu {
	public MatterCapacitorBankMenu(int p_38852_, Inventory inventory) {
		this(p_38852_, inventory, null);
	}

	public MatterLevelWidget<MatterCapacitorBankMenu> matter;

	public MatterCapacitorBankMenu(int p_38852_, Inventory inventory, BlockEntityMatterCapacitorBank tile) {
		super(Registry.Menus.MATTER_CAPACITOR_BANK, p_38852_, inventory, tile);

		if (tile == null) {
			matter = new MatterLevelWidget<>(this, 14, 20);
		} else {
			matter = new MatterLevelWidget<>(this, 14, 20, tile.matter);
		}

		Container container = tile != null ? tile.matter_container : new SimpleContainer(5 * 3);

		for (int row = 0; row < 3; row++)
			for (int column = 0; column < 5; column++)
				this.addSlot(new MatterContainerInputSlot(container, row * 5 + column, 64 + column * 18, 20 + row * 18, true, IMatterHandler.MatterDirection.BIDIRECTIONAL));

		addInventorySlots();
	}

	@Override
	protected int getWorkingSlotStart() {
		return 0;
	}

	@Override
	protected int getWorkingSlotEnd() {
		return 16;
	}
}
